<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;

class PenerimaanbarangioModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table="penerimaanbarangio";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "penerimaanbarangio";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* check the incrementing boolean if the incrementing from database is false then the value is false by default
	*/
	// public $incrementing = false;
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable=[
		"id", "rcNumber", "ioNumber", "userId", "kapalId", "locationId", "status", "unitOperasi", "tanggalPenerimaan", "tanggalPO", "qtyDiterima"	, "voyageKode", "voyageStart", "voyageEnd", "date_updated"
	];
	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"rcNumber" => "penerimaanbarangio.rcNumber",
		"ioNumber" => "penerimaanbarangio.ioNumber",
		"tanggalPenerimaan" => "penerimaanbarangio.tanggalPenerimaan",
	];

	/**
	* relation from ' . kapal . ' by ' . kapalId 
	* join kapal on kapal.id = penerimaanbarangio.kapalId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationKapalId($alias = "kapalId")
	{
		$this->getQuery()->join("kapal as $alias", "$alias.id", "=", "penerimaanbarangio.kapalId");
		return $this;
	}
	/**
	* relation from ' . lokasiitem . ' by ' . locationId 
	* join lokasiitem on lokasiitem.id = penerimaanbarangio.locationId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationLocationId($alias = "locationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "penerimaanbarangio.locationId");
		return $this;
	}
	/**
	* relation from ' . users . ' by ' . userId 
	* join users on users.id = penerimaanbarangio.userId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationUserId($alias = "userId")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "penerimaanbarangio.userId");
		return $this;
	}
	/**
	* relation from ' . itempenerimaanbarangio . ' by ' . penerimaanBarangId 
	* join itempenerimaanbarangio on itempenerimaanbarangio.poNumber = penerimaanbarangio.penerimaanBarangId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationItemPenerimaanBarangIoId($alias = "itempenerimaanbarangio")
	{
		$this->getQuery()->join("itempenerimaanbarangio as $alias", "$alias.rcNumber", "=", "penerimaanbarangio.rcNumber");
		return $this;
	}


	public function joinRelationVoyageKode($alias = "voyageKode")
	{
		$this->getQuery()->leftjoin("voyages as $alias", function($join) use ($alias) {
			$join->on("$alias.voyageKode", "=", "penerimaanbarangio.voyageKode");
			$join->on("$alias.kapalId", "=", "penerimaanbarangio.kapalId");
		});
		return $this;
	}

}